import 'package:flutter/material.dart';
import 'package:provider/provider.dart';

Map _dark = {};
Map _light = {};

class FsContainer extends StatefulWidget {
  final Widget child;
  final Map dark;
  final Map light;
  FsContainer({
    Key? key,
    required this.child,
    required this.dark,
    required this.light,
  }) : super(key: key);

  @override
  _FsContainerState createState() => _FsContainerState();
}

class _FsContainerState extends State<FsContainer> {
  @override
  Widget build(BuildContext context) {
    return MultiProvider(
      providers: [
        ChangeNotifierProvider(
          create: (_) => ThemeColorSax(),
        )
      ],
      child: widget.child,
      builder: (context, child) {
        _dark = widget.dark;
        _light = widget.light;

        return Container(child: child);
      },
    );
  }
}

class ThemeColorSax extends ChangeNotifier {
  ThemeMode themeMode = ThemeMode.dark;
  bool _isDark = false;

  get colors => _isDark ? _dark : _light;
  get isDark => _isDark;

  toggleTheme() {
    _isDark = !_isDark;
    notifyListeners();
  }

  setTheme(bool isDark) {
    _isDark = isDark;
    notifyListeners();
  }
}

ThemeColorSax FsColor(context, [bool listen = true]) {
  return Provider.of<ThemeColorSax>(context, listen: listen);
}

FsToggleTheme(context) {
  Provider.of<ThemeColorSax>(context, listen: false).toggleTheme();
}

FsSetTheme(context, String theme) {
  Provider.of<ThemeColorSax>(context, listen: false)
      .setTheme(theme.toLowerCase() == 'dark');
}
